#!/usr/bin/env ruby

# ==========================================================
# Author : Mikomi
# ==========================================================
# Version : 0.1
# Create : 2007/05/10 
# Last version : 2007/05/11 
# ==========================================================
# Toyunda Manager Launcher
# ==========================================================
# Description :
# Launch the Toyunda Manager Application.
# Require libglade2 and GTK+ to work.
# ==========================================================


puts "init ToyundaManangerMain"

# ----------------------------------------------------------
# Debug / Globale log
# ----------------------------------------------------------

require "constants/CstsMainConfig"

$debug = CstsMainConfig::MAP[CstsMainConfig::DEBUG]
puts("debug = "+$debug.to_s)
$log = File.open(oldlocation(CstsMainConfig::MAP[CstsMainConfig::LOG_FILE_NAME]), 'w')
puts("log file = "+oldlocation(CstsMainConfig::MAP[CstsMainConfig::LOG_FILE_NAME]).to_s)

alias :old_puts :puts 
# override the standard puts method to print log only if debug is active
def puts(pString)
  if $debug > 0
    $log.puts(pString)
    old_puts(pString) if $debug > 1
  end
end

# ----------------------------------------------------------

puts "require ToyundaManangerMain"

# ----------------------------------------------------------
require "gui/ToyundaManagerGUI.rb"
# ----------------------------------------------------------

puts "++ ToyundaManangerMain"
begin
  # Main program 
  Gtk.init
  toyundaManager = GUI::ToyundaManagerGUI.new()
  toyundaManager.start()
  Gtk.main

puts "-- ToyundaManangerMain"
rescue Exception => err
  puts err.to_s
  puts "    "+err.backtrace.join("\n    ")
ensure
  puts "closing log file"
  $log.close
end

